org.apache.ode.bpel.iapi

## Interface ProcessStore

- All Known Implementing Classes:
    ProcessStoreImpl

      public interface ProcessStore

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Collection<javax.xml.namespace.QName>` | `deploy(java.io.File deploymentUnitDirectory)` Deploys a process from the filesystem.
    `long` | `getCurrentVersion()` Gets the version used by the store for the last deployment.
    `java.util.Collection<java.lang.String>` | `getPackages()` Lists the names of all the packages that have been deployed (corresponds to a directory name on the file system).
    `ProcessConf` | `getProcessConfiguration(javax.xml.namespace.QName processId)` Gets all the details of a process configuration (properties, deploy dates, ...)
    `java.util.List<javax.xml.namespace.QName>` | `getProcesses()` Get the list of processes known to the store.
    `java.util.List<javax.xml.namespace.QName>` | `listProcesses(java.lang.String packageName)` Lists all processe ids in a given package.
    `void` | `refreshSchedules(java.lang.String packageName)`
    `void` | `registerListener(ProcessStoreListener psl)` Register a configuration store listener.
    `void` | `setProperty(javax.xml.namespace.QName pid, javax.xml.namespace.QName propName, org.w3c.dom.Node value)`
    `void` | `setProperty(javax.xml.namespace.QName pid, javax.xml.namespace.QName propName, java.lang.String value)` Set a process property.
    `void` | `setRetiredPackage(java.lang.String packageName, boolean retired)` Retires all processes in a given package.
    `void` | `setState(javax.xml.namespace.QName pid, ProcessState state)` Marks a process as active / retired or disabled
    `java.util.Collection<javax.xml.namespace.QName>` | `undeploy(java.io.File file)` Undeploys a package.
    `void` | `unregisterListener(ProcessStoreListener psl)` Unregister a configuration store listener.

- - ### Method Detail

    - #### deploy

          java.util.Collection<javax.xml.namespace.QName> deploy(java.io.File deploymentUnitDirectory)

      Deploys a process from the filesystem.
      Parameters:
        `deploymentUnitDirectory` - directory containing all deployment files
      Returns:
        a collection of process ids (deployed processes)

    - #### undeploy

          java.util.Collection<javax.xml.namespace.QName> undeploy(java.io.File file)

      Undeploys a package.
      Parameters:
        `file` - package
      Returns:
        collection of successfully deployed process names

    - #### getPackages

          java.util.Collection<java.lang.String> getPackages()

      Lists the names of all the packages that have been deployed (corresponds to a directory name on the file system).
      Returns:
        an array of package names

    - #### listProcesses

          java.util.List<javax.xml.namespace.QName> listProcesses(java.lang.String packageName)

      Lists all processe ids in a given package.
      Returns:
        an array of process id QNames

    - #### getProcesses

          java.util.List<javax.xml.namespace.QName> getProcesses()

      Get the list of processes known to the store.
      Returns:
        list of processes qnames with their compiled definition

    - #### getProcessConfiguration

          ProcessConf getProcessConfiguration(javax.xml.namespace.QName processId)

      Gets all the details of a process configuration (properties, deploy dates, ...)
      Parameters:
        `processId` -
      Returns:
        process configuration details

    - #### registerListener

          void registerListener(ProcessStoreListener psl)

      Register a configuration store listener.
      Parameters:
        `psl` - `ProcessStoreListener`

    - #### unregisterListener

          void unregisterListener(ProcessStoreListener psl)

      Unregister a configuration store listener.
      Parameters:
        `psl` - `ProcessStoreListener`

    - #### setProperty

          void setProperty(javax.xml.namespace.QName pid,
                           javax.xml.namespace.QName propName,
                           java.lang.String value)

      Set a process property.
      Parameters:
        `pid` -
        `propName` -
        `value` -

    - #### setProperty

          void setProperty(javax.xml.namespace.QName pid,
                           javax.xml.namespace.QName propName,
                           org.w3c.dom.Node value)

    - #### setState

          void setState(javax.xml.namespace.QName pid,
                        ProcessState state)

      Marks a process as active / retired or disabled
      Parameters:
        `pid` -
        `state` - true for active, false for inactive

    - #### setRetiredPackage

          void setRetiredPackage(java.lang.String packageName,
                                 boolean retired)

      Retires all processes in a given package.
      Parameters:
        `packageName` -
        `retired` -

    - #### getCurrentVersion

          long getCurrentVersion()

      Gets the version used by the store for the last deployment.
      Returns:

    - #### refreshSchedules

          void refreshSchedules(java.lang.String packageName)